//+------------------------------------------------------------------+
//|                                                   MoneyMaker.mq4 |
//|                                                      Coders Guru |
//|                                         http://www.forex-tsd.com |
//+------------------------------------------------------------------+

#property copyright "Coders Guru"
#property link      "http://www.forex-tsd.com"
#define MAGICMA  1990

//---- Trades limits
extern double    TakeProfit=50;
extern double    StopLoss=5;
extern double    TrailingStop=5;
extern double    slippage = 3;
extern double    Lots = 1;
extern int       Level=5;
extern int       Step=5;
extern int       Size=5;
extern int       Expiration = 86400; //1 day
extern int       CurBar = 0;




int init()
  {
   return(0);
  }
int deinit()
  {
   return(0);
  }
  
bool isNewSumbol(string current_symbol)
  {
   //loop through all the opened order and compare the symbols
   int total  = OrdersTotal();
   for(int cnt = 0 ; cnt < total ; cnt++)
   {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      string selected_symbol = OrderSymbol();
      if (current_symbol == selected_symbol)
      return (False);
    }
    return (True);
}

int start()
  {

   if(Bars<100)
     {
      Print("bars less than 100");
      return(0);  
     }
   if(TakeProfit<5)
     {
      Print("TakeProfit less than 10");
      return(0);  // check TakeProfit
     }
   
   
   int total  = OrdersTotal();
   int i=0;
  
   if(total < 1 || isNewSumbol(Symbol())) 
     {
         if(iMA(NULL,0,4,0,MODE_EMA,PRICE_CLOSE,CurBar)>iMA(NULL,0,24,0,MODE_EMA,PRICE_CLOSE,CurBar) && iMA(NULL,0,4,0,MODE_EMA,PRICE_CLOSE,CurBar+1)<iMA(NULL,0,24,0,MODE_EMA,PRICE_CLOSE,CurBar+1))
         {
            for (i = 0 ; i < Size ; i++)
            {
               OpenPendingOrder(OP_BUYSTOP,Lots,Level+(i*Step),slippage,StopLoss,TakeProfit,"MoneyMaker",MAGICMA,CurTime() + Expiration);
            }
          }
          
          if(iMA(NULL,0,4,0,MODE_EMA,PRICE_CLOSE,CurBar)<iMA(NULL,0,24,0,MODE_EMA,PRICE_CLOSE,CurBar) && iMA(NULL,0,4,0,MODE_EMA,PRICE_CLOSE,CurBar+1)> iMA(NULL,0,24,0,MODE_EMA,PRICE_CLOSE,CurBar+1))
          {
            for (i = 0 ; i < Size ; i++)
            {
               OpenPendingOrder(OP_SELLSTOP,Lots,Level+(i*Step),slippage,StopLoss,TakeProfit,"MoneyMaker",MAGICMA,CurTime() + Expiration);
            }
          }
         return(0);
     }
   
     for(int cnt=0;cnt<total;cnt++)
     {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);

      if(OrderType()<=OP_SELL && OrderSymbol()==Symbol())
        {
         if(OrderType()==OP_BUY)   // long position is opened
           {
            // check for trailing stop
            if(TrailingStop>0)  
              {                 
               if(Bid-OrderOpenPrice()>MarketInfo(Symbol(),MODE_POINT)*TrailingStop)
                 {
                  if(OrderStopLoss()<Bid-MarketInfo(Symbol(),MODE_POINT)*TrailingStop)
                    {
                     OrderModify(OrderTicket(),OrderOpenPrice(),Bid-MarketInfo(Symbol(),MODE_POINT)*TrailingStop,OrderTakeProfit(),0,Green);
                     return(0);
                    }
                 }
              }
           }
         if(OrderType()==OP_SELL)  // go to short position
           {
            // check for trailing stop
            if(TrailingStop>0)  
              {                 
               if((OrderOpenPrice()-Ask)>(MarketInfo(Symbol(),MODE_POINT)*TrailingStop))
                 {
                  if((OrderStopLoss()>(Ask+MarketInfo(Symbol(),MODE_POINT)*TrailingStop)) || (OrderStopLoss()==0))
                    {
                     OrderModify(OrderTicket(),OrderOpenPrice(),Ask+MarketInfo(Symbol(),MODE_POINT)*TrailingStop,OrderTakeProfit(),0,Red);
                     return(0);
                    }
                 }
              }
           }
        }
     }

   return(0);
  }
//+------------------------------------------------------------------+

int OpenPendingOrder(int pType=OP_BUYLIMIT,double pLots=1,double pLevel=5,int sp=0, double sl=0,double tp=0,string pComment="",int pMagic=123,datetime pExpiration=0,color pColor=Yellow)
{
  switch (pType)
  {
      case OP_BUYLIMIT:
         return(OrderSend(Symbol(),OP_BUYLIMIT,pLots,Ask-pLevel*Point,sp,(Ask-pLevel*Point)-sl*Point,(Ask-pLevel*Point)+tp*Point,pComment,pMagic,pExpiration,pColor));    
         break;
      case OP_BUYSTOP:
         return(OrderSend(Symbol(),OP_BUYSTOP,pLots,Ask+pLevel*Point,sp,(Ask+pLevel*Point)-sl*Point,(Ask+pLevel*Point)+tp*Point,pComment,pMagic,pExpiration,pColor));     
         break;
      case OP_SELLLIMIT:
         return(OrderSend(Symbol(),OP_SELLLIMIT,pLots,Bid+pLevel*Point,sp,(Bid+pLevel*Point)+sl*Point,(Bid+pLevel*Point)-tp*Point,pComment,pMagic,pExpiration,pColor));    
         break;
      case OP_SELLSTOP:
         return(OrderSend(Symbol(),OP_SELLSTOP,pLots,Bid-pLevel*Point,sp,(Bid-pLevel*Point)+sl*Point,(Bid-pLevel*Point)-tp*Point,pComment,pMagic,pExpiration,pColor));    
         break;
  } 
}


